/*
	D.O. Arquelphos(9821)
	for LSI-C(86)
*/
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>

void main( int ac, char **av )
{
	FILE			*in;
	FILE			*out;
	unsigned char	*buf;
	unsigned char	*filebuf;
	unsigned long	file_ed = 0;
	unsigned long	header_size = 0L;
	unsigned long	header_filest = 0L;
	unsigned long	header_fileed = 0L;
	unsigned long	header_filesize = 0L;
	char			header_filename[13];
	char			out_filename[256];
	unsigned long	nowsize;

	int				i = 0;

	printf( "DO Type4 File Divider 080710 (c)Fac.KUROHANE\n" );

	if( ac == 1 )
	{
		printf( "usage: DODIV4 <filename> <outname_prefix> <dest_dir>\n" );
		return;
	}

	in = fopen( av[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", av[1] );
		return;
	}

	printf( "filename: %s\n", av[1] );

	/* filesize */
	fseek( in, 0, SEEK_END );
	file_ed = ftell( in );
	fseek( in, 0, SEEK_SET );
	printf( "file_size: %lu bytes\n", file_ed );

	/* header */
	buf = ( unsigned char * )calloc( 1, 2 );
	fseek( in, 0, SEEK_SET );
	fread( buf, 2, 1, in );
	header_size = (*( unsigned int *)( buf )) << 4;
	printf( "header_size: %08X\n", header_size );
	free( buf );

	printf( "\n" );

	/* read header */
	buf = ( unsigned char * )calloc( 1, header_size );
	fseek( in, 0, SEEK_SET );
	fread( buf, header_size, 1, in );

	for( i = 0; i != 1024; i++ )
	{
		memset( header_filename, 0, sizeof( header_filename ));

		header_filest = (*( unsigned int *)( buf + ( i * 2 ))) << 4;
		header_fileed = (*( unsigned int *)( buf + (( i * 2 ) + 2 ))) << 4;
		if( header_fileed == 0 ) header_fileed = file_ed;
		header_filesize = header_fileed - header_filest;

		if( header_filest == 0 ) break;

		switch( ac )
		{
			case 2:
				sprintf( out_filename, "BGM_%02d.FMD", i );
				sprintf( header_filename, "BGM_%02d.FMD", i );
				break;
			case 3:
				sprintf( out_filename, "%s_%02d.FMD", av[2], i );
				sprintf( header_filename, "%s_%02d.FMD", av[2], i );
				break;
			case 4:
				sprintf( out_filename, "%s%s_%02d.FMD", av[3], av[2], i );
				sprintf( header_filename, "%s_%02d.FMD", av[2], i );
				break;
		}

		printf( "%04d : %-12s %08lX-%08lX (%lu) ",
			i + 1,
			header_filename,
			header_filest,
			header_fileed,
			header_filesize
		);

		out = fopen( out_filename, "wb+" );
		if( out == NULL )
		{
			printf( "error: can't write %s\n", header_filename );
			goto end;
		}

		fseek( in, header_filest, SEEK_SET );

		filebuf = ( unsigned char * )calloc( 1, 32768 );	/* 32k */
		nowsize = header_filesize;

		while( !( nowsize < 32769 ))
		{
			fread( filebuf, 32768, 1, in );
			fwrite( filebuf, 32768, 1, out );
			nowsize -= 32768;
			printf( "." );
		}
		fread( filebuf, nowsize, 1, in );
		fwrite( filebuf, nowsize, 1, out );

		fclose( out );
		printf( ".\n" );
		free( filebuf );
	}

	printf( "\n" );
	printf( "complete.\n" );
end:;
	free( buf );
	fclose( in );

	return;
}
